Index: /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/HeuristicLab.Algorithms.ALPS-3.3.csproj
===================================================================
--- /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/HeuristicLab.Algorithms.ALPS-3.3.csproj	(revision 12035)
+++ /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/HeuristicLab.Algorithms.ALPS-3.3.csproj	(revision 12036)
@@ -91,6 +91,6 @@
     <Compile Include="EldersEmigrator.cs" />
     <Compile Include="EldersSelector.cs" />
-    <Compile Include="LastSubScopeCloner.cs" />
     <Compile Include="LayerCreator.cs" />
+    <Compile Include="LayerSorter.cs" />
     <Compile Include="LayerUniformSubScopesProcessor.cs" />
     <Compile Include="LayerUpdator.cs" />
Index: anches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/LastSubScopeCloner.cs
===================================================================
--- /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/LastSubScopeCloner.cs	(revision 12035)
+++ 	(revision )
@@ -1,68 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Linq;
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-using HeuristicLab.Data;
-using HeuristicLab.Operators;
-using HeuristicLab.Parameters;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-
-namespace HeuristicLab.Algorithms.ALPS {
-  [Item("LastSubScopeCloner", "An operator which clones the last sub-scope of the current scope.")]
-  [StorableClass]
-  public sealed class LastSubScopeCloner : SingleSuccessorOperator {
-    [StorableConstructor]
-    private LastSubScopeCloner(bool deserializing) : base(deserializing) { }
-
-    private LastSubScopeCloner(LastSubScopeCloner original, Cloner cloner)
-      : base(original, cloner) {
-    }
-    public LastSubScopeCloner()
-      : base() {
-      Parameters.Add(new ScopeParameter("CurrentScope", "The current scope whose sub-scopes should be cloned."));
-      Parameters.Add(new ValueParameter<IntValue>("NumberOfCopies", "The number of copies that should be created.", new IntValue(1)));
-    }
-
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new LastSubScopeCloner(this, cloner);
-    }
-
-    public override IOperation Apply() {
-      var scopes = ExecutionContext.Scope.SubScopes;
-      if (scopes.Count < 1)
-        throw new ArgumentException("At least one sub-scope must exist.");
-
-      var lastSubScope = scopes.Last();
-      var clone = (IScope)lastSubScope.Clone(new Cloner());
-
-      int number;
-      if (int.TryParse(clone.Name, out number))
-        clone.Name = (number + 1).ToString();
-
-      scopes.Add(clone);
-
-      return base.Apply();
-    }
-  }
-}
Index: /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/LayerSorter.cs
===================================================================
--- /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/LayerSorter.cs	(revision 12036)
+++ /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/LayerSorter.cs	(revision 12036)
@@ -0,0 +1,64 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Algorithms.ALPS {
+  [Item("LayerSorter", "")]
+  [StorableClass]
+  public class LayerSorter : SingleSuccessorOperator {
+    private IScopeTreeLookupParameter<IntValue> LayerParameter {
+      get { return (IScopeTreeLookupParameter<IntValue>)Parameters["Layer"]; }
+    }
+
+    [StorableConstructor]
+    private LayerSorter(bool deserializing)
+      : base(deserializing) { }
+    private LayerSorter(LayerSorter original, Cloner cloner)
+      : base(original, cloner) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new LayerSorter(this, cloner);
+    }
+    public LayerSorter()
+      : base() {
+      Parameters.Add(new ScopeTreeLookupParameter<IntValue>("Layer"));
+    }
+
+    public override IOperation Apply() {
+      var layers = ExecutionContext.Scope.SubScopes;
+      layers.Sort(SortLayers);
+
+      return base.Apply();
+    }
+
+    private int SortLayers(IScope x, IScope y) {
+      var lx = (IntValue)x.Variables["Layer"].Value;
+      var ly = (IntValue)y.Variables["Layer"].Value;
+
+      return lx.Value.CompareTo(ly.Value);
+    }
+  }
+}
Index: /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/LayerUpdator.cs
===================================================================
--- /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/LayerUpdator.cs	(revision 12035)
+++ /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/LayerUpdator.cs	(revision 12036)
@@ -29,4 +29,5 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Selection;
 
 namespace HeuristicLab.Algorithms.ALPS {
@@ -60,5 +61,8 @@
       var incrOpenLayers = new IntCounter() { Name = "Incr. OpenLayers" };
       var newLayerResultsCollector = new ResultsCollector() { Name = "Collect new Layer Results" };
-      var newLayerProsessor = new LastSubScopeProcessor();
+      var newLayerSelector = new RightSelector();
+      var newLayerProsessor = new SubScopesProcessor();
+      var newLayerLayerProcessor = new LayerUniformSubScopesProcessor();
+      var newLayerReducer = new MergingReducer();
       var layerInitializer = new Assigner() { Name = "Init Layer" };
       var correctAgeProcessor = new UniformSubScopesProcessor() { Name = "Hack: Decrement Age" };
@@ -66,5 +70,9 @@
       var incrEvaluatedSolutionsForNewLayer = new SubScopesCounter() { Name = "Update EvaluatedSolutions" };
       var newResultCollectionAssigner = new Assigner() { Name = "Empty Results" };
-      var regenerateLayerZeroProsessor = new FirstSubScopeProcessor();
+      var regenerateLayerZeroSelector = new LeftSelector();
+      var regenerateLayerZeroProsessor = new SubScopesProcessor();
+      var regenerateLayerZeroLayerProsessor = new LayerUniformSubScopesProcessor();
+      var regenerateLayerZeroReducer = new MergingReducer();
+      var layerSorter = new LayerSorter();
       var subScopesRemover = new SubScopesRemover();
       var solutionsCreator = new SolutionsCreator();
@@ -99,12 +107,19 @@
       openNewLayerBranch.ConditionParameter.ActualName = "OpenNewLayer";
       openNewLayerBranch.TrueBranch = layerCreator;
-      openNewLayerBranch.Successor = regenerateLayerZeroProsessor;
+      openNewLayerBranch.Successor = regenerateLayerZeroSelector;
 
-      //layerCloner.Successor = newLayerProsessor;
-      layerCreator.Successor = newLayerProsessor;
+      layerCreator.Successor = newLayerSelector;
 
-      //newLayerProsessor.Operator = layerInitializer;
-      newLayerProsessor.Operator = incrEvaluatedSolutionsForNewLayer;
-      newLayerProsessor.Successor = incrOpenLayers;
+      newLayerSelector.NumberOfSelectedSubScopesParameter.Value = new IntValue(1);
+      newLayerSelector.CopySelected = new BoolValue(false);
+      newLayerSelector.Successor = newLayerProsessor;
+
+      newLayerProsessor.Operators.Add(new EmptyOperator());
+      newLayerProsessor.Operators.Add(newLayerLayerProcessor);
+      newLayerProsessor.Successor = newLayerReducer;
+
+      newLayerLayerProcessor.Operator = incrEvaluatedSolutionsForNewLayer;
+
+      newLayerReducer.Successor = incrOpenLayers;
 
       layerInitializer.LeftSideParameter.ActualName = "Layer";
@@ -136,6 +151,17 @@
       newLayerResultsCollector.Successor = null;
 
-      regenerateLayerZeroProsessor.Operator = subScopesRemover;
-      regenerateLayerZeroProsessor.Successor = resetGenSlr;
+      regenerateLayerZeroSelector.NumberOfSelectedSubScopesParameter.Value = new IntValue(1);
+      regenerateLayerZeroSelector.CopySelected = new BoolValue(false);
+      regenerateLayerZeroSelector.Successor = regenerateLayerZeroProsessor;
+
+      regenerateLayerZeroProsessor.Operators.Add(new EmptyOperator());
+      regenerateLayerZeroProsessor.Operators.Add(regenerateLayerZeroLayerProsessor);
+      regenerateLayerZeroProsessor.Successor = regenerateLayerZeroReducer;
+
+      regenerateLayerZeroLayerProsessor.Operator = subScopesRemover;
+
+      regenerateLayerZeroReducer.Successor = layerSorter;
+
+      layerSorter.Successor = resetGenSlr;
 
       subScopesRemover.Successor = solutionsCreator;