Index: anches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/AgeDistributionAnalyzer.cs
===================================================================
--- /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/AgeDistributionAnalyzer.cs	(revision 12045)
+++ 	(revision )
@@ -1,137 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System.Linq;
-using HeuristicLab.Analysis;
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-using HeuristicLab.Data;
-using HeuristicLab.Operators;
-using HeuristicLab.Optimization;
-using HeuristicLab.Parameters;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-
-namespace HeuristicLab.Algorithms.ALPS {
-  // Based on QualityDistributionAnalyzer
-  [Item("AgeDistributionAnalyzer", "Analyzes the distribution of the ages in that it adds a Histogram of them into the result collection.")]
-  [StorableClass]
-  public sealed class AgeDistributionAnalyzer : SingleSuccessorOperator, IAnalyzer, IIterationBasedOperator {
-
-    #region Parameter Properties
-    public IScopeTreeLookupParameter<IntValue> AgeParameter {
-      get { return (IScopeTreeLookupParameter<IntValue>)Parameters["Age"]; }
-    }
-    public ValueLookupParameter<ResultCollection> ResultsParameter {
-      get { return (ValueLookupParameter<ResultCollection>)Parameters["Results"]; }
-    }
-    private ValueParameter<StringValue> HistogramNameParameter {
-      get { return (ValueParameter<StringValue>)Parameters["HistogramName"]; }
-    }
-    private ValueParameter<BoolValue> StoreHistoryParameter {
-      get { return (ValueParameter<BoolValue>)Parameters["StoreHistory"]; }
-    }
-    public ILookupParameter<IntValue> IterationsParameter {
-      get { return (ILookupParameter<IntValue>)Parameters["Iterations"]; }
-    }
-    public IValueLookupParameter<IntValue> MaximumIterationsParameter {
-      get { return (IValueLookupParameter<IntValue>)Parameters["MaximumIterations"]; }
-    }
-    #endregion
-
-    public bool EnabledByDefault { get { return false; } }
-
-    public string HistogramName {
-      get { return HistogramNameParameter.Value.Value; }
-      set { HistogramNameParameter.Value.Value = value; }
-    }
-    public bool StoreHistory {
-      get { return StoreHistoryParameter.Value.Value; }
-      set { StoreHistoryParameter.Value.Value = value; }
-    }
-
-    [StorableConstructor]
-    private AgeDistributionAnalyzer(bool deserializing)
-      : base(deserializing) { }
-    private AgeDistributionAnalyzer(AgeDistributionAnalyzer original, Cloner cloner)
-      : base(original, cloner) { }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new AgeDistributionAnalyzer(this, cloner);
-    }
-    public AgeDistributionAnalyzer()
-      : base() {
-      Parameters.Add(new ScopeTreeLookupParameter<IntValue>("Age", "The value which represents the age of a solution."));
-      Parameters.Add(new ValueLookupParameter<ResultCollection>("Results", "The results collection where the analysis values should be stored."));
-      Parameters.Add(new FixedValueParameter<StringValue>("HistogramName", "The name of the histogram that gets injected in to the results collection.", new StringValue("Age Distribution")));
-      Parameters.Add(new FixedValueParameter<BoolValue>("StoreHistory", "True if the history should be stored in addition to the current distribution", new BoolValue(false)));
-      Parameters.Add(new LookupParameter<IntValue>("Iterations", "Optional: A value indicating the current iteration."));
-      Parameters.Add(new ValueLookupParameter<IntValue>("MaximumIterations", "Unused", new IntValue(-1)));
-
-      AgeParameter.Hidden = true;
-      ResultsParameter.Hidden = true;
-      IterationsParameter.Hidden = true;
-      MaximumIterationsParameter.Hidden = true;
-    }
-
-    public override IOperation Apply() {
-      DataTable ageDistribution = null;
-      ResultCollection results = ResultsParameter.ActualValue;
-      string description = "Shows the age distributions in the current population.";
-      if (results.ContainsKey(HistogramName)) {
-        ageDistribution = results[HistogramName].Value as DataTable;
-      } else {
-        ageDistribution = new DataTable("Population Age Distribution", description);
-        ageDistribution.VisualProperties.XAxisTitle = AgeParameter.ActualName;
-        ageDistribution.VisualProperties.YAxisTitle = "Frequency";
-        results.Add(new Result(HistogramName, description, ageDistribution));
-      }
-      DataRow row;
-      if (!ageDistribution.Rows.TryGetValue("AgeDistribution", out row)) {
-        row = new DataRow("AgeDistribution");
-        row.VisualProperties.ChartType = DataRowVisualProperties.DataRowChartType.Histogram;
-        ageDistribution.Rows.Add(row);
-      }
-      var ages = AgeParameter.ActualValue;
-      row.Values.Replace(ages.Select(x => (double)x.Value));
-
-      if (StoreHistory) {
-        string historyResultName = HistogramName + " History";
-        DataTableHistory adHistory = null;
-        if (results.ContainsKey(historyResultName)) {
-          adHistory = results[historyResultName].Value as DataTableHistory;
-        } else {
-          adHistory = new DataTableHistory();
-          results.Add(new Result(historyResultName, adHistory));
-        }
-        DataTable table = (DataTable)ageDistribution.Clone();
-        IntValue iteration = IterationsParameter.ActualValue;
-        if (iteration != null) {
-          string iterationName = IterationsParameter.ActualName;
-          if (iterationName.EndsWith("s")) iterationName = iterationName.Remove(iterationName.Length - 1);
-          string appendix = " at " + iterationName + " " + iteration.Value.ToString();
-          table.Name += appendix;
-          table.Rows["AgeDistribution"].VisualProperties.DisplayName += appendix;
-        }
-        adHistory.Add(table);
-      }
-      return base.Apply();
-    }
-  }
-}
Index: /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/Analyzers/AgeDistributionAnalyzer.cs
===================================================================
--- /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/Analyzers/AgeDistributionAnalyzer.cs	(revision 12046)
+++ /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/Analyzers/AgeDistributionAnalyzer.cs	(revision 12046)
@@ -0,0 +1,137 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
+using HeuristicLab.Analysis;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Algorithms.ALPS {
+  // Based on QualityDistributionAnalyzer
+  [Item("AgeDistributionAnalyzer", "Analyzes the distribution of the ages in that it adds a Histogram of them into the result collection.")]
+  [StorableClass]
+  public sealed class AgeDistributionAnalyzer : SingleSuccessorOperator, IAnalyzer, IIterationBasedOperator {
+
+    #region Parameter Properties
+    public IScopeTreeLookupParameter<IntValue> AgeParameter {
+      get { return (IScopeTreeLookupParameter<IntValue>)Parameters["Age"]; }
+    }
+    public ValueLookupParameter<ResultCollection> ResultsParameter {
+      get { return (ValueLookupParameter<ResultCollection>)Parameters["Results"]; }
+    }
+    private ValueParameter<StringValue> HistogramNameParameter {
+      get { return (ValueParameter<StringValue>)Parameters["HistogramName"]; }
+    }
+    private ValueParameter<BoolValue> StoreHistoryParameter {
+      get { return (ValueParameter<BoolValue>)Parameters["StoreHistory"]; }
+    }
+    public ILookupParameter<IntValue> IterationsParameter {
+      get { return (ILookupParameter<IntValue>)Parameters["Iterations"]; }
+    }
+    public IValueLookupParameter<IntValue> MaximumIterationsParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["MaximumIterations"]; }
+    }
+    #endregion
+
+    public bool EnabledByDefault { get { return false; } }
+
+    public string HistogramName {
+      get { return HistogramNameParameter.Value.Value; }
+      set { HistogramNameParameter.Value.Value = value; }
+    }
+    public bool StoreHistory {
+      get { return StoreHistoryParameter.Value.Value; }
+      set { StoreHistoryParameter.Value.Value = value; }
+    }
+
+    [StorableConstructor]
+    private AgeDistributionAnalyzer(bool deserializing)
+      : base(deserializing) { }
+    private AgeDistributionAnalyzer(AgeDistributionAnalyzer original, Cloner cloner)
+      : base(original, cloner) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new AgeDistributionAnalyzer(this, cloner);
+    }
+    public AgeDistributionAnalyzer()
+      : base() {
+      Parameters.Add(new ScopeTreeLookupParameter<IntValue>("Age", "The value which represents the age of a solution."));
+      Parameters.Add(new ValueLookupParameter<ResultCollection>("Results", "The results collection where the analysis values should be stored."));
+      Parameters.Add(new FixedValueParameter<StringValue>("HistogramName", "The name of the histogram that gets injected in to the results collection.", new StringValue("Age Distribution")));
+      Parameters.Add(new FixedValueParameter<BoolValue>("StoreHistory", "True if the history should be stored in addition to the current distribution", new BoolValue(false)));
+      Parameters.Add(new LookupParameter<IntValue>("Iterations", "Optional: A value indicating the current iteration."));
+      Parameters.Add(new ValueLookupParameter<IntValue>("MaximumIterations", "Unused", new IntValue(-1)));
+
+      AgeParameter.Hidden = true;
+      ResultsParameter.Hidden = true;
+      IterationsParameter.Hidden = true;
+      MaximumIterationsParameter.Hidden = true;
+    }
+
+    public override IOperation Apply() {
+      DataTable ageDistribution = null;
+      ResultCollection results = ResultsParameter.ActualValue;
+      string description = "Shows the age distributions in the current population.";
+      if (results.ContainsKey(HistogramName)) {
+        ageDistribution = results[HistogramName].Value as DataTable;
+      } else {
+        ageDistribution = new DataTable("Population Age Distribution", description);
+        ageDistribution.VisualProperties.XAxisTitle = AgeParameter.ActualName;
+        ageDistribution.VisualProperties.YAxisTitle = "Frequency";
+        results.Add(new Result(HistogramName, description, ageDistribution));
+      }
+      DataRow row;
+      if (!ageDistribution.Rows.TryGetValue("AgeDistribution", out row)) {
+        row = new DataRow("AgeDistribution");
+        row.VisualProperties.ChartType = DataRowVisualProperties.DataRowChartType.Histogram;
+        ageDistribution.Rows.Add(row);
+      }
+      var ages = AgeParameter.ActualValue;
+      row.Values.Replace(ages.Select(x => (double)x.Value));
+
+      if (StoreHistory) {
+        string historyResultName = HistogramName + " History";
+        DataTableHistory adHistory = null;
+        if (results.ContainsKey(historyResultName)) {
+          adHistory = results[historyResultName].Value as DataTableHistory;
+        } else {
+          adHistory = new DataTableHistory();
+          results.Add(new Result(historyResultName, adHistory));
+        }
+        DataTable table = (DataTable)ageDistribution.Clone();
+        IntValue iteration = IterationsParameter.ActualValue;
+        if (iteration != null) {
+          string iterationName = IterationsParameter.ActualName;
+          if (iterationName.EndsWith("s")) iterationName = iterationName.Remove(iterationName.Length - 1);
+          string appendix = " at " + iterationName + " " + iteration.Value.ToString();
+          table.Name += appendix;
+          table.Rows["AgeDistribution"].VisualProperties.DisplayName += appendix;
+        }
+        adHistory.Add(table);
+      }
+      return base.Apply();
+    }
+  }
+}
Index: /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/Analyzers/OldestAverageYoungestAgeAnalyzer.cs
===================================================================
--- /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/Analyzers/OldestAverageYoungestAgeAnalyzer.cs	(revision 12046)
+++ /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/Analyzers/OldestAverageYoungestAgeAnalyzer.cs	(revision 12046)
@@ -0,0 +1,140 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Analysis;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Optimization.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Algorithms.ALPS {
+  [Item("OldestAverageYoungestAgeAnalyzer", "An operator which calculates the current oldest, average and youngest age in the scope tree.")]
+  [StorableClass]
+  public sealed class OldestAverageYoungestAgeAnalyzer : AlgorithmOperator, IAnalyzer {
+    #region Parameter properties
+    public IScopeTreeLookupParameter<IntValue> AgeParameter {
+      get { return (IScopeTreeLookupParameter<IntValue>)Parameters["Age"]; }
+    }
+    public IValueLookupParameter<IntValue> CurrentOldestAgeParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["CurrentOldestAge"]; }
+    }
+    public IValueLookupParameter<IntValue> CurrentAverageAgeParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["CurrentAverageAge"]; }
+    }
+    public IValueLookupParameter<IntValue> CurrentYoungestAgeParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["CurrentYoungestAge"]; }
+    }
+    public IValueLookupParameter<DataTable> AgesParameter {
+      get { return (IValueLookupParameter<DataTable>)Parameters["Ages"]; }
+    }
+    public ValueLookupParameter<ResultCollection> ResultsParameter {
+      get { return (ValueLookupParameter<ResultCollection>)Parameters["Results"]; }
+    }
+    #endregion
+
+    #region Properties
+    public bool EnabledByDefault {
+      get { return true; }
+    }
+    private OldestAverageYoungestAgeCalculator OldestAverageYoungestAgeCalculator {
+      get { return (OldestAverageYoungestAgeCalculator)OperatorGraph.InitialOperator; }
+    }
+    #endregion
+
+    #region Storing & Cloning
+    [StorableConstructor]
+    private OldestAverageYoungestAgeAnalyzer(bool deserializing) : base(deserializing) { }
+    private OldestAverageYoungestAgeAnalyzer(OldestAverageYoungestAgeAnalyzer original, Cloner cloner)
+      : base(original, cloner) {
+      Initialize();
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new OldestAverageYoungestAgeAnalyzer(this, cloner);
+    }
+    #endregion
+    public OldestAverageYoungestAgeAnalyzer()
+      : base() {
+      #region Create parameters
+      Parameters.Add(new ScopeTreeLookupParameter<IntValue>("Age", "The value which represents the age of a solution."));
+      Parameters.Add(new ValueLookupParameter<IntValue>("CurrentOldestAge", "The oldest age value found in the current population."));
+      Parameters.Add(new ValueLookupParameter<IntValue>("CurrentAverageAge", "The average age value of all solutions in the current population."));
+      Parameters.Add(new ValueLookupParameter<IntValue>("CurrentYoungestAge", "The youngest age value found in the current population."));
+      Parameters.Add(new ValueLookupParameter<DataTable>("Ages", "The data table to store the current oldest, current average, current youngest age value."));
+      Parameters.Add(new ValueLookupParameter<ResultCollection>("Results", "The results collection where the analysis values should be stored."));
+
+      CurrentOldestAgeParameter.Hidden = true;
+      CurrentAverageAgeParameter.Hidden = true;
+      CurrentYoungestAgeParameter.Hidden = true;
+      AgesParameter.Hidden = true;
+      #endregion
+
+      #region Create operators
+      var oldestAverageYoungestAgeCalculator = new OldestAverageYoungestAgeCalculator();
+      var dataTableValuesCollector = new DataTableValuesCollector();
+      var resultsCollector = new ResultsCollector();
+
+      oldestAverageYoungestAgeCalculator.AverageAgeParameter.ActualName = CurrentAverageAgeParameter.Name;
+      oldestAverageYoungestAgeCalculator.OldestAgeParameter.ActualName = CurrentOldestAgeParameter.Name;
+      oldestAverageYoungestAgeCalculator.AgeParameter.ActualName = AgeParameter.Name;
+      oldestAverageYoungestAgeCalculator.AgeParameter.Depth = AgeParameter.Depth;
+      oldestAverageYoungestAgeCalculator.YoungestAgeParameter.ActualName = CurrentYoungestAgeParameter.Name;
+
+      dataTableValuesCollector.CollectedValues.Add(new LookupParameter<IntValue>("CurrentOldestAge", null, CurrentOldestAgeParameter.Name));
+      dataTableValuesCollector.CollectedValues.Add(new LookupParameter<IntValue>("CurrentAverageAge", null, CurrentAverageAgeParameter.Name));
+      dataTableValuesCollector.CollectedValues.Add(new LookupParameter<IntValue>("CurrentYoungestAge", null, CurrentYoungestAgeParameter.Name));
+      dataTableValuesCollector.DataTableParameter.ActualName = AgesParameter.Name;
+
+      resultsCollector.CollectedValues.Add(new LookupParameter<IntValue>("CurrentOldestAge", null, CurrentOldestAgeParameter.Name));
+      resultsCollector.CollectedValues.Add(new LookupParameter<IntValue>("CurrentAverageAge", null, CurrentAverageAgeParameter.Name));
+      resultsCollector.CollectedValues.Add(new LookupParameter<IntValue>("CurrentYoungestAge", null, CurrentYoungestAgeParameter.Name));
+      resultsCollector.CollectedValues.Add(new LookupParameter<DataTable>(AgesParameter.Name));
+      resultsCollector.ResultsParameter.ActualName = ResultsParameter.Name;
+      #endregion
+
+      #region Create operator graph
+      OperatorGraph.InitialOperator = oldestAverageYoungestAgeCalculator;
+      oldestAverageYoungestAgeCalculator.Successor = dataTableValuesCollector;
+      dataTableValuesCollector.Successor = resultsCollector;
+      resultsCollector.Successor = null;
+      #endregion
+
+      Initialize();
+    }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      Initialize();
+    }
+
+    private void Initialize() {
+      AgeParameter.DepthChanged += new EventHandler(AgeParameter_DepthChanged);
+    }
+
+    private void AgeParameter_DepthChanged(object sender, EventArgs e) {
+      OldestAverageYoungestAgeCalculator.AgeParameter.Depth = AgeParameter.Depth;
+    }
+  }
+}
Index: /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/Analyzers/OldestAverageYoungestAgeCalculator.cs
===================================================================
--- /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/Analyzers/OldestAverageYoungestAgeCalculator.cs	(revision 12046)
+++ /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/Analyzers/OldestAverageYoungestAgeCalculator.cs	(revision 12046)
@@ -0,0 +1,91 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Algorithms.ALPS {
+  [Item("OldestAverageYoungestAgeCalculator", "An operator which calculates the oldest, average and youngest age of solutions in the scope tree.")]
+  [StorableClass]
+  public class OldestAverageYoungestAgeCalculator : SingleSuccessorOperator {
+    public IScopeTreeLookupParameter<IntValue> AgeParameter {
+      get { return (IScopeTreeLookupParameter<IntValue>)Parameters["Age"]; }
+    }
+    public IValueLookupParameter<IntValue> OldestAgeParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["OldestAge"]; }
+    }
+    public IValueLookupParameter<IntValue> AverageAgeParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["AverageAge"]; }
+    }
+    public IValueLookupParameter<IntValue> YoungestAgeParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["YoungestAge"]; }
+    }
+
+    #region Storing & Cloning
+    [StorableConstructor]
+    private OldestAverageYoungestAgeCalculator(bool deserializing) : base(deserializing) { }
+    private OldestAverageYoungestAgeCalculator(OldestAverageYoungestAgeCalculator original, Cloner cloner) : base(original, cloner) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new OldestAverageYoungestAgeCalculator(this, cloner);
+    }
+    #endregion
+
+    public OldestAverageYoungestAgeCalculator()
+      : base() {
+      Parameters.Add(new ScopeTreeLookupParameter<IntValue>("Age", "The value contained in the scope tree which represents the solution age."));
+      Parameters.Add(new ValueLookupParameter<IntValue>("OldestAge", "The age value of the oldest solution."));
+      Parameters.Add(new ValueLookupParameter<IntValue>("AverageAge", "The average age of all solutions."));
+      Parameters.Add(new ValueLookupParameter<IntValue>("YoungestAge", "The age value of the youngest solution."));
+
+      OldestAgeParameter.Hidden = true;
+      AverageAgeParameter.Hidden = true;
+      YoungestAgeParameter.Hidden = true;
+    }
+
+    public override IOperation Apply() {
+      var ages = AgeParameter.ActualValue;
+
+      if (ages.Length > 0) {
+        int min = int.MaxValue, max = int.MinValue, sum = 0;
+        for (int i = 0; i < ages.Length; i++) {
+          if (ages[i].Value < min) min = ages[i].Value;
+          if (ages[i].Value > max) max = ages[i].Value;
+          sum += ages[i].Value;
+        }
+
+        var oldest = OldestAgeParameter.ActualValue;
+        if (oldest == null) OldestAgeParameter.ActualValue = new IntValue(max);
+        else oldest.Value = max;
+        var average = AverageAgeParameter.ActualValue;
+        if (average == null) AverageAgeParameter.ActualValue = new IntValue(sum / ages.Length);
+        else average.Value = sum / ages.Length;
+        var youngest = YoungestAgeParameter.ActualValue;
+        if (youngest == null) YoungestAgeParameter.ActualValue = new IntValue(min);
+        else youngest.Value = min;
+      }
+      return base.Apply();
+    }
+  }
+}
Index: /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/HeuristicLab.Algorithms.ALPS-3.3.csproj
===================================================================
--- /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/HeuristicLab.Algorithms.ALPS-3.3.csproj	(revision 12045)
+++ /branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/HeuristicLab.Algorithms.ALPS-3.3.csproj	(revision 12046)
@@ -85,8 +85,10 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="AgeDistributionAnalyzer.cs" />
+    <Compile Include="Analyzers\OldestAverageYoungestAgeAnalyzer.cs" />
+    <Compile Include="Analyzers\AgeDistributionAnalyzer.cs" />
     <Compile Include="AgingScheme.cs" />
     <Compile Include="AlpsGeneticAlgorithm.cs" />
     <Compile Include="AlpsGeneticAlgorithmMainLoop.cs" />
+    <Compile Include="Analyzers\OldestAverageYoungestAgeCalculator.cs" />
     <Compile Include="EldersEmigrator.cs" />
     <Compile Include="EldersSelector.cs" />